{% load static %}
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>AquaGuage</title>
  <link href="{% static 'graph/css/home.css' %}" type="text/css" rel="stylesheet" />
  <!--FONT AWESOME ICONS https://fontawesome.com/v4.7/icon/home-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css" />
  <!--Chart JS-->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.4/Chart.js"></script>
  <!-- JQuery -->
  <script src="{% static 'common/js/jquery-3.6.4.min.js' %}"></script>
  <style>
    .container {
      width: 96%;
      margin-left: auto;
      margin-right: auto;
    }

    .row {
      display: flex;
      flex-direction: row;
      margin-top: 1em;
      padding: 1em;
    }

    select,
    button {
      width: 95%;
      display: block;
      padding: 9px;
      margin: 1%;
      border: none;
      outline: none;
    }

    .col-md-4 {
      flex: 30%;
      display: flex;
      flex-direction: row;
    }

    button {
      background-color: #ff9900;
      color: white;
      width: 100px;
      border: 1px solid #ff9900;
      cursor: pointer;
    }

    button:hover {
      color: #ff9900;
      background-color: white;
    }

    .select-btn {
      background-color: #ffffff;
      border: none;
      color: gray;
      font-size: 23px;
      width: 50px;
    }

    .select-btn:hover {
      background-color: #ff9900;
      color: white;
    }

    table {
      width: 95%;
      margin-left: auto;
      margin-right: auto;
      min-height: 20vh;
    }

    td,
    th {
      text-align: left;
      padding: 5px;
    }

    tr:nth-child(even) {
      background-color: #e5ffff;
    }

    @media screen and (max-width: 720px) {
      .row {
        flex-direction: column;
      }
    }
  </style>
</head>

<body>
  <div class="header box-shadow">
    <div class="flex-row-header">
      <div class="flex-col-header">
        <h2>AquaGauge</h2>
      </div>
      <div class="flex-col-header">
        <img class="logo" src="{% static 'home/images/icfoss_logo.png' %}" />
      </div>
      <div class="flex-col-header">
        <a href="/" class="a-view">
          <h3><i class="fa fa-sign-in" aria-hidden="true"></i> Home</h3>
        </a>
      </div>
    </div>
  </div>

  <div class="container text-center">
    <div class="row box-shadow">
      <div class="col-md-4">
        <select name="" id="" onchange="get_wells(this.value)">
          <option value="-1">Select school</option>
          {% for each in schools %}
          <option value="{{each.id}}">{{each.name}}</option>
          {% endfor %}
        </select>
      </div>
      <div class="col-md-4">
        <select name="" id="wells">
          <option value="-1">Select well</option>
        </select>
      </div>
      <div class="col-md-4">
        <button onclick="view_data('d-1')">View</button>
        <button class="select-btn" onclick="show_table()">
          <i class="fa fa-table" aria-hidden="true"></i>
        </button>
        <button class="select-btn" onclick="show_graph()">
          <i class="fa fa-line-chart" aria-hidden="true"></i>
        </button>
        <select name="" id="" onchange="view_data(this.value)">
          <option value="d-1">24 Hours</option>
          <option value="w-1">Last Week</option>
          <option value="m-1">Last Month</option>
          <option value="y-1">Last Year</option>
          <option value="f-f">Full</option>
        </select>
      </div>
    </div>


    <div class="row" id="graph-view">
      <canvas id="myChart" style="width: 100%; max-width: 600px"></canvas>
      <canvas id="myChart2" style="width: 100%; max-width: 600px"></canvas>
    </div>

    <div class="row box-shadow" id="table-view" style="display: none;">
      <table>
        <thead>
          <tr>
            <th>Date</th>
            <th>Value</th>
          </tr>
        <tbody id="tbody-data">
          <!-- <tr>
            <td>2333-32-23-2323-23--323</td>
            <td>23.3</td>
          </tr> -->
        </tbody>
        </thead>
      </table>
    </div>


  </div>
  <br>

  <div class="footer box-shadow">
    <div class="flex-row-footer">
      <div class="flex-col-footer"></div>
      <div class="flex-col-footer">
        <p>
          Developed CDOH <br />
          International Centre for Free and Open Source Software
        </p>
      </div>
      <div class="flex-col-footer"></div>
    </div>
  </div>

  <script>
    const xValues = [0];
    const yValues = [0];

    status_chart = new Chart("myChart", {
      type: "line",
      data: {
        labels: xValues,
        datasets: [
          {
            fill: false,
            lineTension: 0,
            backgroundColor: "rgba(0,0,255,1.0)",
            borderColor: "rgba(0,0,255,0.1)",
            data: yValues,
          },
        ],
      },
      options: {
        legend: { display: false },
        scales: {
            xAxes: [{
                scaleLabel: {
                    display: true,
                    labelString: 'Time'
                }
            }],
            yAxes: [{
                ticks: {
                    min: 6,
                    max: 1000
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Water level (cm)'
                }
            }]
        },
        title: {
          display: true,
          text: 'Open well data'
        },
      },
    });

    var level_chart = new Chart("myChart2", {
  type: "bar", // Change type to 'bar'
  data: {
    labels: xValues,
    datasets: [
      {
        backgroundColor: "rgba(0,0,255,1.0)",
        data: yValues,
      },
    ],
  },
  options: {
    legend: { display: false },
    scales: {
      xAxes: [
        {
          scaleLabel: {
            display: true,
            labelString: "Well",
          },
        },
      ],
      yAxes: [
        {
          ticks: {
            min: 6,
            max: 1000,
          },
          scaleLabel: {
            display: true,
            labelString: "Last Water level (cm)",
          },
        },
      ],
    },
    title: {
      display: true,
      text: "Last levels",
    },
  },
});


    // level_chart = new Chart("myChart2", {
    //   type: "line",
    //   data: {
    //     labels: xValues,
    //     datasets: [
    //       {
    //         fill: false,
    //         lineTension: 0,
    //         backgroundColor: "rgba(0,0,255,1.0)",
    //         borderColor: "rgba(0,0,255,0.1)",
    //         data: yValues,
    //       },
    //     ],
    //   },
    //   options: {
    //     legend: { display: false },
    //     scales: {
    //         xAxes: [{
    //             scaleLabel: {
    //                 display: true,
    //                 labelString: 'Well'
    //             }
    //         }],
    //         yAxes: [{
    //             ticks: {
    //                 min: 6,
    //                 max: 1000
    //             },
    //             scaleLabel: {
    //                 display: true,
    //                 labelString: 'Last Water level (cm)'
    //             }
    //         }]
    //     },
    //     title: {
    //       display: true,
    //       text: 'Last levels'
    //     },
    //   },
    // });
  </script>



  <script>

    function get_wells(school_id) {
      if (school_id == -1) {
        alert('Plese select a school ');
        return;
      }
      document.getElementById("wells").innerHTML = "<option value='-1'>Select well</option>";
      $.fetchWells(school_id);
    }

    $.fetchWells = function (school_id) {
      $.ajax({
        type: "GET",
        url: "/graphs/wells",
        data: {
          'school_id': school_id
        },
        success: function (data) {
          let data_ = data;
          let options = "";
          data = data['wells'];
          jQuery.each(data, function (index, item) {
            $("#wells").append(
              '<option value="' + item['id'] + '">' + item['label'] + "</option>"
            );
          });

          data = data_['well_level'];
          console.log(data);
          const labelList = data.map(({ label }) => label);
          const levelList = data.map(({ level }) => level);

          level_chart.data.labels = labelList;
          level_chart.data.datasets[0].data = levelList;
          level_chart.update();


        },
      });
    };


    function view_data(data_range) {
      well_id = document.getElementById("wells").value;
      if (well_id == -1) {
        alert('Plese select a well ');
        return;
      }
      document.getElementById("tbody-data").innerHTML = "";
      $.fetchData(well_id, data_range);
    }

    $.fetchData = function (well_id, data_range) {
      $.ajax({
        type: "GET",
        url: "well/" + well_id + "/" + data_range,
        data: {

        },
        success: function (data) {
          data = data['well_data']
          jQuery.each(data, function (index, item) {
            $("#tbody-data").append(
              '<tr><td>' + item['datetime'] + '</td><td>' + item['water_level'] + '</td></tr>'
            );
          });

          const datetimeList = data.map(({ datetime }) => datetime);
          const water_levelList = data.map(({ water_level }) => water_level);

          status_chart.data.labels = datetimeList;
          status_chart.data.datasets[0].data = water_levelList;
          status_chart.update();
        },
      });
    };


    function show_table() {
      document.getElementById('graph-view').style.display = 'none';
      document.getElementById('table-view').style.display = 'flex';
    }

    function show_graph() {
      document.getElementById('graph-view').style.display = 'flex';
      document.getElementById('table-view').style.display = 'none';
    }

  </script>

</body>

</html>